Bio::PrimarySeq(3)

NAME
Bio::PrimarySeq - Bioperl lightweight Sequence Object

SYNOPSIS
  # The Bio::SeqIO for file reading, Bio::DB::GenBank for
  # database reading
  use Bio::Seq;
  use Bio::SeqIO;
  use Bio::DB::GenBank;
  #make from memory
  $seqobj = Bio::PrimarySeq->new ( -seq => 'ATGGGGTGGGCGGTGGGTGGTTTG',
                            -id  => 'GeneFragment-12',
                            -accession_number => 'X78121',
                            -moltype => 'dna'
                            );
  # read from file
  $inputstream = Bio::SeqIO->new(-file => "myseq.fa",-format => 'Fasta');
  $seqobj = $inputstream->next_seq();
  # get from database
  $db = Bio::DB::GenBank->new();
  $seqobj = $db->get_Seq_by_acc('X78121');
  # to get out parts of the sequence.
  print "Sequence ", $seqobj->id(), " with accession ", $seqobj->accession, " and desc ", $seqobj->desc, "\n";
  $string  = $seqobj->seq();
  $string2 = $seqobj->subseq(1,40);

DESCRIPTION
PrimarySeq is a lightweight Sequence object, storing little more than the sequence, its name, a computer useful unique name. It does not contain sequence features or other information. To have a sequence with sequence features you should use the Seq object which uses this object.

Sequence objects are defined by the Bio::PrimarySeqI interface, and this object is a pure Perl implementation of the interface (if that's gibberish to you, don't worry. The take home message is that this object is the bioperl default sequence object, but other people can use their own objects as sequences if they so wish). If you are interested in wrapping your own objects as compliant Bioperl sequence objects, then you should read the Bio::PrimarySeqI documentation

The documenation of this object is a merge of the Bio::PrimarySeq and Bio::PrimarySeqI documentation. This allows all the methods which you can call on sequence objects here.

Reimplementation
The Sequence object was completely rewritten for the 0.6 series. This was because the old Sequence object was becoming heavily bloated and difficult to maintain. There are some key changes from the old object to the new object, but basically, everything should work with the new object with a minimal number of changes.

The key change is that the format IO has been removed from this object and moved to the Bio::SeqIO system, which provides a much better way to encapsulate the sequence format reading. Please read the SeqIO documentation, but the take home message is that lines like

    # old style reading from files
    $seq = Bio::Seq->new( -file => "myfile");
Becomes

    # new style reading from files.
    $inputstream = Bio::SeqIO->new( -file => "myfile", -format => 'Fasta');
    $seqobj = $inputstream->next_seq();
For writing files, a similar system is used

     # old style writing to files
     print OUTPUT $seq->layout_fasta;
     # new style writing to files
     $outputstream = Bio::SeqIO->new( -fh => \*OUTPUT, -format => 'Fasta');
     $outputstream->write_seq($seqobj);

  Deprecated methods
A number of methods which were present in the old 0.04/0.05 series have been deprecated. Most of these methods work as before, but provide a warning that someone has called a deprecated method.

getseq - use seq/subseq instead
str - use seq/subseq instead
ary - use seq/subseq with your own split afterwards
type - use moltype, but notice that moltype returns different values (lowercase)

FEEDBACK

  Mailing Lists
User feedback is an integral part of the evolution of this and other Bioperl modules. Send your comments and suggestions preferably to one of the Bioperl mailing lists. Your participation is much appreciated.

  bioperl-l@bioperl.org             - General discussion
  http://bio.perl.org/MailList.html - About the mailing lists

  Reporting Bugs
Report bugs to the Bioperl bug tracking system to help us keep track the bugs and their resolution. Bug reports can be submitted via email or the web:

  bioperl-bugs@bio.perl.org
  http://bio.perl.org/bioperl-bugs/

AUTHOR - Ewan Birney
Email birney@sanger.ac.uk

Describe contact details here

APPENDIX
The rest of the documentation details each of the object methods. Internal methods are usually preceded with a _

  new
 Title   : new
 Usage   : $seq    = Bio::PrimarySeq->new( -seq => 'ATGGGGGTGGTGGTACCCT',
                                           -id  => 'human_id',
                                           -accession_number => 'AL000012',
                                           );
 Function: Returns a new primary seq object from
           basic constructors, being a string for the sequence
           and strings for id and accession_number.
           Note that you can provide an empty sequence string. However, in
           this case you MUST specify the type of sequence you wish to
           initialize by the parameter -moltype. See moltype() for possible
           values.
 Returns : a new Bio::PrimarySeq object
 Args    : -seq         => sequence string
           -display_id  => display id of the sequence (locus name)
           -accession_number => accession number
           -primary_id  => primary id (Genbank id)
           -desc        => description text
           -moltype     => molecule type (dna,rna,prot)
           -id          => alias for display id

  seq
 Title   : seq
 Usage   : $string    = $obj->seq()
 Function: Returns the sequence as a string of letters. The
           case of the letters is left up to the implementer.
           Suggested cases are upper case for proteins and lower case for
           DNA sequence (IUPAC standard), but you should not rely on this
 Returns : A scalar

  validate_seq
 Title   : validate_seq
 Usage   : if(! $seq->validate_seq($seq_str) ) {
                print "sequence $seq_str is not valid for an object of type ",
                      ref($seq), "\n";
           }
 Function: Validates a given sequence string. A validating sequence string
           must be accepted by seq(). A string that does not validate will
           lead to an exception if passed to seq().
           The implementation provided here does not take moltype() into
           account. Allowed are all letters (A-Z) and '-','.', and '*'.
 Example :
 Returns : TRUE if the supplied sequence string is valid for the object, and
           FALSE otherwise.
 Args    : The sequence string to be validated.

  subseq
 Title   : subseq
 Usage   : $substring = $obj->subseq(10,40);
 Function: returns the subseq from start to end, where the first base
           is 1 and the number is inclusive, ie 1-2 are the first two
           bases of the sequence
 Returns : a string
 Args    :

  length
 Title   : length
 Usage   : $len = $seq->length()
 Function:
 Example :
 Returns : integer representing the length of the sequence.
 Args    :

  display_id
 Title   : display_id
 Usage   : $id_string = $obj->display_id();
 Function: returns the display id, aka the common name of the Sequence object.
         The semantics of this is that it is the most likely string to be
         used as an identifier of the sequence, and likely to have "human" readability.
         The id is equivalent to the ID field of the GenBank/EMBL databanks and
         the id field of the Swissprot/sptrembl database. In fasta format, the >(\S+)
         is presumed to be the id, though some people overload the id to embed other
         information. Bioperl does not use any embedded information in the ID field,
         and people are encouraged to use other mechanisms (accession field for example,
         or extending the sequence object) to solve this.
 Returns : A string
 Args    : None

  accession_number
 Title   : accession_number
 Usage   : $unique_key = $obj->accession_number;
 Function: Returns the unique biological id for a sequence, commonly
           called the accession_number. For sequences from established
           databases, the implementors should try to use the correct
           accession number. Notice that primary_id() provides the
           unique id for the implemetation, allowing multiple objects
           to have the same accession number in a particular implementation.
           For sequences with no accession number, this method should return
           "unknown".
 Returns : A string
 Args    : A string (optional) for setting

  primary_id
 Title   : primary_id
 Usage   : $unique_key = $obj->primary_id;
 Function: Returns the unique id for this object in this
           implementation. This allows implementations to manage
           their own object ids in a way the implementaiton can control
           clients can expect one id to map to one object.
           For sequences with no natural primary id, this method should return
           a stringified memory location.
 Returns : A string
 Args    : A string (optional, for setting)

  moltype
 Title   : moltype
 Usage   : if( $obj->moltype eq 'dna' ) { /Do Something/ }
 Function: Returns the type of sequence being one of
           'dna', 'rna' or 'protein'. This is case sensitive.
           This is not called <type> because this would cause
           upgrade problems from the 0.5 and earlier Seq objects.
 Returns : a string either 'dna','rna','protein'. NB - the object must
           make a call of the type - if there is no type specified it
           has to guess.
 Args    : none

  desc
 Title   : desc
 Usage   : $obj->desc($newval)
 Function: Get/set description of the sequence.
 Example :
 Returns : value of desc
 Args    : newvalue (optional)

  can_call_new
 Title   : can_call_new
 Usage   :
 Function:
 Example :
 Returns :
 Args    :

  id
 Title   : id
 Usage   : $id = $seq->id()
 Function: This is mapped on display_id
 Example :
 Returns :
 Args    :

Methods Inherieted from Bio::PrimarySeqI
These methods are available on Bio::PrimarySeq, although they are actually implemented on Bio::PrimarySeqI

  revcom
 Title   : revcom
 Usage   : $rev = $seq->revcom()
 Function: Produces a new Bio::SeqI implementing object which
           is the reversed complement of the sequence. For protein
           sequences this throws an exception of
           "Sequence is a protein. Cannot revcom"
           The id is the same id as the orginal sequence, and the
           accession number is also indentical. If someone wants to
           track that this sequence has be reversed, it needs to
           define its own extensions
           To do an inplace edit of an object you can go:
           $seqobj = $seqobj->revcom();
           This of course, causes Perl to handle the garbage
           collection of the old object, but it is roughly speaking as
           efficient as an inplace edit.
 Returns : A new (fresh) Bio::SeqI object
 Args    : none

  trunc
 Title   : trunc
 Usage   : $subseq = $myseq->trunc(10,100);
 Function: Provides a truncation of a sequence,
 Example :
 Returns : a fresh Bio::SeqI implementing object
 Args    :

Internal methods
These are internal methods to PrimarySeq

  _guess_type
 Title   : _guess_type
 Usage   :
 Function:
 Example :
 Returns :
 Args    :